-- カーソルを動かす関数定義。
-- 以下は借り物コードです。目的に高級すぎかもですが,
-- おかげで後のカスタム、変更が容易になるでしょう。
-- Thankyou,KMaki,joule!
-- http://forum.renoise.com/index.php?/topic/32240-snippet-edit-step/
local s = nil

function move_cursor_wrapping(step)
  local pos_table = { }
  local i = 0
  local current_pos = nil
  
  for sequence in ipairs(s.sequencer.pattern_sequence) do
    for pos,column in s.pattern_iterator:lines_in_pattern_track(s.sequencer.pattern_sequence[sequence], s.selected_track_index) do
      i = i + 1
      pos_table[i] = { pattern = pos.pattern, line = pos.line, sequence = sequence }
      if sequence == s.selected_sequence_index and pos.line == s.selected_line_index then
        current_pos = i
      end
    end
  end
  
  if pos_table[current_pos+(step)] then
    s.selected_sequence_index = pos_table[current_pos+step].sequence
    s.selected_line_index = pos_table[current_pos+step].line
  else
    if step > 0 then
      --ram to bottom
      s.selected_sequence_index = pos_table[table.count(pos_table)].sequence
      s.selected_line_index = pos_table[table.count(pos_table)].line
    else
      --ram to top
      s.selected_sequence_index = 1
      s.selected_line_index = 1
    end
  end
  
end


function move_cursor(step)
  s = renoise.song()
  step = step or s.transport.edit_step  --default value for no args call=current edit_step
  if step == 0 then end --no movement
  local new_position = s.selected_line_index + step
  if new_position > s.selected_pattern.number_of_lines or new_position < 1 then
    if s.transport.wrapped_pattern_edit then
      --move between patterns
      move_cursor_wrapping(step)
    else
      --wrap around pattern edges
      if step > 0 then
        s.selected_line_index = new_position - s.selected_pattern.number_of_lines
      else
        s.selected_line_index = s.selected_pattern.number_of_lines + new_position
      end
    end
  else
    s.selected_line_index = new_position
  end
end
