-- Functions for serching next or prvious notes
-- by uprime22
--[[
-- Search a next or previous note's position at the same Track,NoteColumn.
-- no_wrap_option:
-- true, continuously pattrn editing,
-- false ,wraped in the pattern.
 EX.:
serch_next_note(
renoise.song().selected_sequence_index
,renoise.song().selected_track_index
,renoise.song().selected_line_index
,renoise.song().selected_note_column_index
,renoise.song().transport.wrapped_pattern_edit)
--]]

function serch_next_note (seq_idx,trk_idx,line_idx,note_column_idx,no_wrap_option)
  local seq_tbl = renoise.song().sequencer.pattern_sequence  
  if seq_idx > #seq_tbl or seq_idx < 1
    or note_column_idx == nil or note_column_idx == 0 -- API Manual mistake ?
    or line_idx == nil or trk_idx == nil
  then
    return nil
  end
  local pt = renoise.song()
  .patterns[(renoise.song().sequencer:pattern(seq_idx))]
  local line_max = pt.number_of_lines
  local nxt_sq ,nxt_tk ,nxt_nc = seq_idx ,trk_idx ,note_column_idx
  local nxt_ln
  for l = (line_idx +1) , line_max do
    if pt.tracks[trk_idx].lines[l].note_columns[note_column_idx]
      .is_empty == false
    then
      nxt_ln = l
      break
    end
  end
  if nxt_ln == nil and no_wrap_option == false then
    return nil
  elseif nxt_ln == nil and no_wrap_option == true then
    nxt_sq,nxt_tk,nxt_ln,nxt_nc =
    serch_next_note (seq_idx +1,trk_idx,0,note_column_idx,no_wrap_option)
  end
  return nxt_sq,nxt_tk,nxt_ln,nxt_nc,no_wrap_option
end


function serch_previous_note (seq_idx,trk_idx,line_idx,note_column_idx,no_wrap_option)
  local seq_tbl = renoise.song().sequencer.pattern_sequence  
  if seq_idx > #seq_tbl or seq_idx < 1
    or note_column_idx == nil or note_column_idx == 0 -- API Manual mistake ?
    or line_idx == nil or trk_idx == nil
  then
    return nil
  end
  local pt = renoise.song()
  .patterns[(renoise.song().sequencer:pattern(seq_idx))]
  local line_max = pt.number_of_lines
  if line_idx == 0 then
    line_idx = line_max +1
  end
  local nxt_sq ,nxt_tk ,nxt_nc = seq_idx ,trk_idx ,note_column_idx
  local nxt_ln
  for l = (line_idx -1) , 1, -1 do
    if pt.tracks[trk_idx].lines[l].note_columns[note_column_idx]
      .is_empty == false
    then
      nxt_ln = l
      break
    end
  end
  if nxt_ln == nil and no_wrap_option == false then
    return nil
  elseif nxt_ln == nil and no_wrap_option == true then
    nxt_sq,nxt_tk,nxt_ln,nxt_nc =
    serch_previous_note (seq_idx -1,trk_idx,0,note_column_idx,no_wrap_option)
  end
  return nxt_sq,nxt_tk,nxt_ln,nxt_nc,no_wrap_option
end



function next_note_exist ()
  local sq = serch_next_note(
    renoise.song().selected_sequence_index
    ,renoise.song().selected_track_index
    ,renoise.song().selected_line_index
    ,renoise.song().selected_note_column_index
    ,renoise.song().transport.wrapped_pattern_edit)
  if sq == nil then sq = false
  else sq = true
  end
  return sq
end
  

function move_to_next_note (on_off)
  local seq,trk,ln =
  serch_next_note(
    renoise.song().selected_sequence_index
    ,renoise.song().selected_track_index
    ,renoise.song().selected_line_index
    ,renoise.song().selected_note_column_index
    ,renoise.song().transport.wrapped_pattern_edit)
  if seq ~= nil and on_off ~= false then
    renoise.song().selected_sequence_index = seq    
    renoise.song().selected_line_index = ln
  end
  return seq,ln
end


function move_to_previous_note (on_off)
  local seq,trk,ln =
  serch_previous_note(
    renoise.song().selected_sequence_index
    ,renoise.song().selected_track_index
    ,renoise.song().selected_line_index
    ,renoise.song().selected_note_column_index
    ,renoise.song().transport.wrapped_pattern_edit)
  if seq ~= nil and on_off ~= false then
    renoise.song().selected_sequence_index = seq    
    renoise.song().selected_line_index = ln
  end
  return seq,ln
end


  